import logo from './logo.svg';
import './App.css';
import React, { useEffect, useState } from 'react';

// LCD
// TimerContainer
const TimerContainer = ({ seconds, refresh, render }) => {
    const [count, setCount] = useState(seconds) // отслеживаем состояние количества секунд
    const [isRunning, setIsRunning] = useState(false) // отслеживаем состояние кнопки стоп/старт для таймера
    const Render = render

    useEffect(() => { setCount(seconds) }, [seconds]) // синхронизируем count с передаваемыми seconds

    console.log('count ', count)

    // Таймер
    useEffect(() => { // эффект, отвечающий за то, когда счетчик прошле в 0, он его переводит в состояние паузы
        if (count <= 0) {
            setIsRunning(false)
        }
    }, [count <= 0])

    useEffect(() => { // сам счетчик
        if (isRunning) {
            const start = performance.now()

            const int = setInterval(() => {

                const diff = Math.floor((performance.now() - start) / refresh)
                setCount(count => count - diff)
            }, refresh)

            return () => clearInterval(int)
        }
    })

    return (
        <div>
            <Render ms={count} />
            <button onClick={() => setIsRunning(!isRunning)}>{isRunning ? 'Pause' : 'Start'}</button>
        </div >
    )
}

const Timer = ({ ms }) => {

    // функция-перевод секунд в нормальный вид
    function timerFormat(time) {
        const h = Math.floor(time / 60 / 60)
        const m = Math.floor(time / 60) - (h * 60)
        const s = time % 60

        const defaultZero = (param) => (param > 9) ? param : '0' + param

        return `${defaultZero(h)} : ${defaultZero(m)} : ${defaultZero(s)}`
    }

    return (
        <div>
            <h2>TimerContainer</h2>
            {timerFormat(ms)}
        </div >
    )
}

function App() {
    return (
        <div className="App">
            <header>

                {/* TimerContainer */}
                <TimerContainer seconds={1800} refresh={100} render={Timer} />

            </header>
        </div>
    );
}

export default App;